#[doc = "Register `INTR_CAN` reader"]
pub struct R(crate::R<INTR_CAN_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<INTR_CAN_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<INTR_CAN_SPEC>> for R {
    fn from(reader: crate::R<INTR_CAN_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `INTR_CAN` writer"]
pub struct W(crate::W<INTR_CAN_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<INTR_CAN_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<INTR_CAN_SPEC>> for W {
    fn from(writer: crate::W<INTR_CAN_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `INT_STATUS` writer - Triggers when any enabled (INT_EBL) interrupt are set in INT_STATUS"]
pub struct INT_STATUS_W<'a> {
    w: &'a mut W,
}
impl<'a> INT_STATUS_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !0x01) | (value as u32 & 0x01);
        self.w
    }
}
#[doc = "Field `TT_COMPARE` writer - Triggers when LOCAL_TIME is equal to TT_COMPARE"]
pub struct TT_COMPARE_W<'a> {
    w: &'a mut W,
}
impl<'a> TT_COMPARE_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 1)) | ((value as u32 & 0x01) << 1);
        self.w
    }
}
#[doc = "Field `TT_CAPTURE` writer - Triggers when LOCAL_TIME is saved to TT_CAPTURE, on SOF detection"]
pub struct TT_CAPTURE_W<'a> {
    w: &'a mut W,
}
impl<'a> TT_CAPTURE_W<'a> {
    #[doc = r"Sets the field bit"]
    #[inline(always)]
    pub fn set_bit(self) -> &'a mut W {
        self.bit(true)
    }
    #[doc = r"Clears the field bit"]
    #[inline(always)]
    pub fn clear_bit(self) -> &'a mut W {
        self.bit(false)
    }
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub fn bit(self, value: bool) -> &'a mut W {
        self.w.bits = (self.w.bits & !(0x01 << 2)) | ((value as u32 & 0x01) << 2);
        self.w
    }
}
impl W {
    #[doc = "Bit 0 - Triggers when any enabled (INT_EBL) interrupt are set in INT_STATUS"]
    #[inline(always)]
    pub fn int_status(&mut self) -> INT_STATUS_W {
        INT_STATUS_W { w: self }
    }
    #[doc = "Bit 1 - Triggers when LOCAL_TIME is equal to TT_COMPARE"]
    #[inline(always)]
    pub fn tt_compare(&mut self) -> TT_COMPARE_W {
        TT_COMPARE_W { w: self }
    }
    #[doc = "Bit 2 - Triggers when LOCAL_TIME is saved to TT_CAPTURE, on SOF detection"]
    #[inline(always)]
    pub fn tt_capture(&mut self) -> TT_CAPTURE_W {
        TT_CAPTURE_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u32) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "CAN Interrupt Cause (TTCAN + INT_STATUS Or)\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [intr_can](index.html) module"]
pub struct INTR_CAN_SPEC;
impl crate::RegisterSpec for INTR_CAN_SPEC {
    type Ux = u32;
}
#[doc = "`read()` method returns [intr_can::R](R) reader structure"]
impl crate::Readable for INTR_CAN_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [intr_can::W](W) writer structure"]
impl crate::Writable for INTR_CAN_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets INTR_CAN to value 0"]
impl crate::Resettable for INTR_CAN_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
